FUNCTION Main()

   LOCAL oObject

   CLS
   ? "Press any key to start"
   INKEY( 0 )

   WITH OBJECT oObject  := Image():New( "name1" )
      :Row     := 10
      :Title   := "this is a tile"
   END WITH

   ? "Name  value is >" + hb_ValToExp( oObject:Name ) + "<"
   ? "Title value is >" + hb_ValToExp( oObject:Title ) + "<"
   ? "Row   value is >" + hb_ValToExp( oObject:Row ) + "<"

   ? "Press any key to end"
   INKEY( 0 )


RETURN NIL


#include "hbclass.ch"
#include "common.ch"

/*============================================================================
   Basic class
============================================================================*/
CLASS Basic

   DATA cName                 INIT   NIL      PROTECTED
   DATA oParent               INIT   NIL      PROTECTED

   METHOD   New
   METHOD   Name
   METHOD   Parent

ENDCLASS

/*............................................................................
   New
............................................................................*/
METHOD New( oParent ) CLASS Basic

   IF hb_isobject( oParent )
      ::oParent    := oParent
//   ELSEIF hb_isobject( oParent := HB_QWith() )
//      ::oParent    := oParent
   ENDIF

RETURN Self

/*............................................................................
   Name
............................................................................*/
METHOD Name() CLASS Basic

RETURN ::cName

/*............................................................................
   Parent
............................................................................*/
METHOD Parent() CLASS Basic

RETURN ::oParent


/*============================================================================
   Control class
============================================================================*/
CLASS Control FROM Basic

   DATA nRow                  INIT   NIL      PROTECTED
   DATA cImage                INIT   NIL      PROTECTED

   METHOD   Image             SETGET
   METHOD   Row               SETGET

ENDCLASS

/*............................................................................
   Image
............................................................................*/
METHOD Image( cArg1 ) CLASS Control

   IF PCOUNT() == 0
      ::cImage := IIF( hb_IsNil( ::cImage ) == .T., "", ::cImage )
      RETURN ::cImage
   ELSEIF hb_IsChar( cArg1 ) == .T.
      ::cImage := cArg1
   ENDIF

RETURN Self

/*............................................................................
   Row
............................................................................*/
METHOD Row( nArg1 ) CLASS Control

   IF PCOUNT() == 0
      ::nRow := IIF( hb_IsNil( ::nRow ) == .T., 0, ::nRow )
      RETURN ::nRow
   ELSEIF hb_IsNumeric( nArg1 ) == .T.
      ::nRow := nArg1
   ENDIF

RETURN Self

/*============================================================================
   Image class
============================================================================*/
CLASS Image FROM Control

   DATA cTitle                INIT   NIL      PROTECTED

   METHOD   New
   METHOD   Title             SETGET

ENDCLASS

/*............................................................................
   New
............................................................................*/
METHOD New( cName, oParent ) CLASS Image

   ::cName  := cName
//   cName := IIF( hb_IsChar( cName ) == .T. , cName, "Nome" )
   
   Super:New( oParent )

RETURN Self

/*............................................................................
   Title
............................................................................*/
METHOD Title( cArg1 ) CLASS Image

   IF PCOUNT() == 0
      ::cTitle := IIF( hb_IsNil( ::cTitle ) == .T., "", ::cTitle )
      RETURN ::cTitle
   ELSEIF hb_IsChar( cArg1 ) == .T.
      ::cTitle := cArg1
   ENDIF

RETURN Self



